Attribute VB_Name = "PScriptMain"
Option Explicit

Private Declare Sub ExitProcess Lib "kernel32" (ByVal uExitCode As POtherErrors)

Private ScriptControl As MSScriptControl.ScriptControl

Private Sub Main()
    Dim Result As POtherErrors
    
    Result = PScriptObject.ParseCommands()
    Select Case Result
        Case poeNoError
            Set ScriptControl = New MSScriptControl.ScriptControl
            With ScriptControl
                .Language = PScriptObject.Language
                .AllowUI = True 'Note: means Timeouts raise a dialog!
                .AddObject "PScript", PScriptObject, True
                .Timeout = PScriptObject.ScriptTimeout
                Dim F As Integer
                Dim Code As String
                
                F = FreeFile(0)
                Open PScriptObject.ScriptFullName For Input As #F
                Code = Input$(LOF(F), #F)
                Close #F
                On Error Resume Next
                .AddCode Code
                On Error GoTo 0
                With .Error
                    Select Case .Number
                        Case 0, 51
                            .Clear
                        Case Else
                            MsgBox .Source & ", line " & CStr(.Line) _
                                 & " column " & CStr(.Column + 1) _
                                 & ": " & .Description & vbNewLine & vbNewLine _
                                 & .Text, _
                                   vbOKOnly Or vbExclamation
                            Result = poeScriptError
                    End Select
                End With
            End With
            Set ScriptControl = Nothing
        Case poeBadExtension
            MsgBox "Script file extension not valid for " & App.EXEName & vbNewLine & vbNewLine _
                 & "Saw: " & PScriptObject.OtherErrorInfo, _
                   vbOKOnly Or vbExclamation
        Case poeScriptNotFound
            MsgBox "Script file name provided cannot be found", vbOKOnly Or vbExclamation
        'Case Else
            'We already showed Usage.
    End Select
    Set PScriptObject = Nothing
    ExitProcess Result
End Sub
